/* Problem URL: https://codeforces.com/contest/2106/problem/G1 */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        vvi graph(n);
        rep(i, n - 1) {
            int a, b;
            cin >> a >> b;
            a--, b--;

            graph[a].push_back(b);
            graph[b].push_back(a);
        }

        cout << "? 1 1 1" << endl;
        int ans;
        cin >> ans;

        if (ans > 1 || ans < -1) {
            cout << "? 2 1" << endl;
            ans = 0;
        }

        vi tmp(n);
        nrep(i, 1, n) {
            cout << "? 1 1 " << i + 1 << endl;
            int now;
            cin >> now;

            tmp[i] = now - ans;
        }

        int one = 0;
        if (ans == 0) {
            cout << "? 2 1" << endl;
            int fds;
            cout << "? 1 1 1" << endl;
            cin >> fds;

            if (fds == -2) {
                one = -1;
            } else {
                one = 1;
            }
        } else {
            one = ans;
        }

        tmp[0] = one;

        cout << "! ";
        repv(i, tmp) {
            cout << ' ' << i;
        }
        cout << endl;
    }
}
